import java.awt.*;

/**An action is something that is triggered at a certain time or by
 * some event. Actions do things like moving to another timeline, changing
 * an element going to another web page
 */
abstract class Action
{
	static String ename[] = {
		"Timer", "MouseClick", "MouseEnter", "MouseExit"
		};
	Object owner;
	int event;
	int time;

	/**Called when this action is triggered */
	abstract void activate(Presentation p);

	HData save()
	{
	HData hd = new HData();
	hd.addString("class", getClass().getName());
	hd.addInteger("event", event);
	hd.addInteger("time", time);
	return hd;
	}

	void load(HData hd)
	{
	event = hd.getInteger("event");
	time = hd.getInteger("time");
	}

	static Action loadAction(HData hd)
	{
	Action na = (Action)Util.createObject(hd.getString("class"));
	na.load(hd);
	return na;
	}
}

