import java.awt.*;

class ActionEditor extends Panel implements CbButtonCallback
{
	ActionsWindow parent;
	Action act;

	Panel left, right;
	TextField time;
	CbButton save;

	void edit(ActionsWindow p, Action a)
	{
	parent = p;
	act = a;
	makeUI();
	}

	protected void makeUI()
	{
	setLayout(new BorderLayout());
	Panel top = new GrayPanel();
	top.setLayout(new BorderLayout());
	Panel topl = new GrayPanel();	
	topl.setLayout(new GridLayout(0, 1));
	topl.add(new Label("Event:"));
	topl.add(new Label("Action:"));
	if (act.event == 0)
		topl.add(new Label("Time:"));
	top.add("West", topl);
	Panel topr = new GrayPanel();
	topr.setLayout(new GridLayout(0, 1));
	topr.add(new Label(Action.ename[act.event]));
	topr.add(new Label(act.getClass().getName()));
	if (act.event == 0)
		topr.add(time = new TextField(String.valueOf(act.time)));
	top.add("Center", topr);
	add("North", top);

	Panel bot = new GrayPanel();
	bot.setLayout(new FlowLayout(FlowLayout.RIGHT));
	bot.add(save = new CbButton("Save", this));
	add("South", bot);

	Panel mmid = new BorderPanel(1);
	mmid.setLayout(new BorderLayout());
	Panel mid = new GrayPanel();
	mid.setLayout(new BorderLayout());
	left = new GrayPanel(); left.setLayout(new GridLayout(0, 1));
	right = new GrayPanel(); right.setLayout(new GridLayout(0, 1));
	mid.add("West", left); mid.add("Center", right);
	mmid.add("North", mid);
	add("Center", mmid);
	}

	protected boolean apply()
	{
	if (act.event == 0) {
		int t;
		if ((t = getNum(time)) < 0) {
			new ErrorWindow("Event time must be a positive number");
			return false;
			}
		act.time = t;
		}
	return true;
	}

	protected int getNum(TextField t)
	{
	try { return Integer.parseInt(t.getText()); }
	catch(Exception e) { return -Integer.MAX_VALUE; }
	}

	public void click(CbButton b)
	{
	if (b == save) {
		if (!apply()) return;

		// Is this a new action?
		if (parent.acts.indexOf(act) < 0) {
			parent.acts.addElement(act);
			parent.addToList(act);
			parent.actions.select(parent.acts.size()-1);
			}
		}
	}
}

