import java.awt.*;

class ArcElement extends Element
{
	int xoff, yoff;
	int thick = 1;
	boolean side = false;
	boolean arrow1, arrow2;

	void paint(Graphics g, boolean e)
	{
	g.setColor(fcol);
	if (side) {
		// ends of arc are points left or right
		if (xoff > 0 && yoff > 0)
			g.drawArc(x, y-yoff, xoff*2, yoff*2, 180, 90);
		else if (xoff > 0)
			g.drawArc(x, y+yoff, xoff*2, -yoff*2, 90, 90);
		else if (yoff > 0)
			g.drawArc(x+xoff*2, y-yoff, -xoff*2, yoff*2, 270, 90);
		else
			g.drawArc(x+xoff*2, y+yoff, -xoff*2, -yoff*2, 0, 90);
		if (arrow2) harrow(g, x+xoff, y+yoff, xoff);
		if (arrow1) varrow(g, x, y, -yoff);
		}
	else {
		// ends are pointing up or down
		if (xoff > 0 && yoff > 0)
			g.drawArc(x-xoff, y, xoff*2, yoff*2, 0, 90);
		else if (xoff > 0)
			g.drawArc(x-xoff, y+yoff*2, xoff*2, -yoff*2, 270, 90);
		else if (yoff > 0)
			g.drawArc(x+xoff, y, -xoff*2, yoff*2, 90, 90);
		else
			g.drawArc(x+xoff, y+yoff*2, -xoff*2, -yoff*2, 180, 90);
		if (arrow2) varrow(g, x+xoff, y+yoff, yoff);
		if (arrow1) harrow(g, x, y, -xoff);
		}
	}

	private void harrow(Graphics g, int x, int y, int d)
	{
	d = (d > 0 ? 1 : -1);
	int xp[] = { x, x, x+d*8 };
	int yp[] = { y-4, y+4, y };
	g.fillPolygon(xp, yp, 3);
	}

	private void varrow(Graphics g, int x, int y, int d)
	{
	d = (d > 0 ? 1 : -1);
	int xp[] = { x-4, x+4, x };
	int yp[] = { y, y, y+d*8 };
	g.fillPolygon(xp, yp, 3);
	}

	void create(Dimension d, Color f, Color b)
	{
	xoff = d.width; yoff = d.height;
	fcol = f;
	}

	int getStyle()
	{
	return 1;
	}

	Point[] getEndPoints()
	{
	Point rv[] = { new Point(x, y), new Point(x+xoff, y+yoff) };
	return rv;
	}

	void setSize(int nw, int nh)
	{
	xoff = nw; yoff = nh;
	}

	void copy(Element t)
	{
	ArcElement at = (ArcElement)t;
	at.xoff = xoff; at.yoff = yoff;
	at.side = side;
	at.thick = thick;
	at.arrow1 = arrow1; at.arrow2 = arrow2;
	}

	HData save()
	{
	HData hd = super.save();
	hd.addInteger("xoff", xoff); hd.addInteger("yoff", yoff);
	hd.addBoolean("side", side);
	hd.addInteger("thick", thick);
	hd.addBoolean("arrow1", arrow1); hd.addBoolean("arrow2", arrow2);
	return hd;
	}

	void load(HData hd)
	{
	super.load(hd);
	xoff = hd.getInteger("xoff"); yoff = hd.getInteger("yoff");
	side = hd.getBoolean("side");
	thick = hd.getInteger("thick");
	arrow1 = hd.getBoolean("arrow1"); arrow2 = hd.getBoolean("arrow2");
	}
}

