import java.awt.*;

class ArcElementEditor extends ElementEditor
{
	ArcElement a;
	TextField xoff, yoff, thick;
	CbColorButton fcol;
	Choice side, arrows;

	protected void makeUI()
	{
	super.makeUI();
	a = (ArcElement)elm;
	pan.setLayout(new GridLayout(0, 2));
	pan.add(new Label("X offset:"));
	pan.add(xoff = new TextField(String.valueOf(a.xoff)));
	pan.add(new Label("Y offset:"));
	pan.add(yoff = new TextField(String.valueOf(a.yoff)));
	pan.add(new Label("Thickness:"));
	pan.add(thick = new TextField(String.valueOf(a.thick)));
	pan.add(new Label("Curve:"));
	pan.add(side = new Choice());
	side.addItem("Vertical");
	side.addItem("Horizontal");
	side.select(a.side?1:0);
	pan.add(new Label("Color:"));
	pan.add(fcol = new CbColorButton(a.fcol));
	pan.add(new Label("Arrows:"));
	pan.add(arrows = new Choice());
	arrows.addItem("None");
	arrows.addItem("Start");
	arrows.addItem("End");
	arrows.addItem("Both");
	arrows.select((a.arrow1?1:0) + (a.arrow2?2:0));
	}

	protected boolean apply()
	{
	int x, y, t;
	if ((x = getNum(xoff)) == -Integer.MAX_VALUE) {
		new ErrorWindow("X offset must be a positive number");
		return false;
		}
	if ((y = getNum(yoff)) == -Integer.MAX_VALUE) {
		new ErrorWindow("Y offset must be a positive number");
		return false;
		}
	if ((t = getNum(thick)) <= 0 || t > 10) {
		new ErrorWindow("Thickness must be a positive number "+
		                "less than 10");
		return false;
		}
	if (!super.apply()) return false;
	a.xoff = x; a.yoff = y;
	a.thick = t; a.fcol = fcol.col;
	a.side = (side.getSelectedIndex()==1);
	a.arrow1 = (arrows.getSelectedIndex()%2 == 1);
	a.arrow2 = (arrows.getSelectedIndex() > 1);
	return true; 
	}
}

