import java.awt.*;

class BoxElement extends Element
{
	int w,h;
	boolean rounded;
	int round = 50;
	int thick = 1;

	void paint(Graphics g, boolean e)
	{
	g.setColor(fcol);
	for(int i=0; i<thick; i++) {
		if (rounded) g.drawRoundRect(x+i, y+i,
		                             w-1-i*2, h-1-i*2, round, round);
		else g.drawRect(x+i, y+i, w-1-i*2, h-1-i*2);
		}
	}

	void create(Dimension d, Color f, Color b)
	{
	setSize(d.width, d.height);
	fcol = f;
	}

	Rectangle getBounds()
	{
	return new Rectangle(x, y, w, h);
	}

	void setSize(int nw, int nh)
	{
	w = nw; h = nh;
	}

	void copy(Element t)
	{
	BoxElement bt = (BoxElement)t;
	bt.w = w; bt.h = h;
	bt.rounded = rounded;
	bt.thick = thick;
	bt.round = round;
	super.copy(t);
	}

	HData save()
	{
	HData hd = super.save();
	hd.addInteger("w", w); hd.addInteger("h", h);
	hd.addBoolean("rounded", rounded);
	hd.addInteger("round", round);
	hd.addInteger("thick", thick);
	return hd;
	}

	void load(HData hd)
	{
	super.load(hd);
	w = hd.getInteger("w"); h = hd.getInteger("h");
	rounded = hd.getBoolean("rounded");
	round = hd.getInteger("round");
	thick = hd.getInteger("thick");
	}
}
