import java.awt.*;

class BoxElementEditor extends ElementEditor
{
	TextField width, height, thick, round;
	Checkbox rounding, nrounding;
	CbColorButton fcol;
	BoxElement b;

	protected void makeUI()
	{
	super.makeUI();
	b = (BoxElement)elm;
	pan.setLayout(new GridLayout(0, 2));
	pan.add(new Label("Width:"));
	pan.add(width = new TextField(String.valueOf(b.w)));
	pan.add(new Label("Height:"));
	pan.add(height = new TextField(String.valueOf(b.h)));
	pan.add(new Label("Thickness:"));
	pan.add(thick = new TextField(String.valueOf(b.thick)));
	pan.add(new Label("Rounded:"));
	Panel rp = new GrayPanel();
	rp.setLayout(new GridLayout(1, 2));
	CheckboxGroup rg = new CheckboxGroup();
	rp.add(rounding = new Checkbox("Yes", rg, b.rounded));
	rp.add(nrounding = new Checkbox("No", rg, !b.rounded));
	pan.add(rp);
	pan.add(new Label("Corner Size:"));
	pan.add(round = new TextField(String.valueOf(b.round)));
	pan.add(new Label("Color:"));
	pan.add(fcol = new CbColorButton(b.fcol));
	}

	protected boolean apply()
	{
	int w, h, t, r;
	if ((w = getNum(width)) < 0) {
		new ErrorWindow("Width must be a positive number");
		return false;
		}
	if ((h = getNum(height)) < 0) {
		new ErrorWindow("Height must be a positive number");
		return false;
		}
	if ((t = getNum(thick)) < 0 || t > 10) {
		new ErrorWindow("Thickness must be a positive number "+
				"less than 10");
		return false;
		}
	boolean rd = rounding.getState();
	if ((r = getNum(round)) < 0) {
		new ErrorWindow("Round size must be a positive number");
		return false;
		}
	Color c = fcol.col;
	if (!super.apply()) return false;
	b.w = w;
	b.h = h;
	b.thick = t;
	b.rounded = rd; b.round = r;
	b.fcol = c;
	return true;
	}
}