import java.awt.*;
import java.util.*;

/**Component for choosing the background and foreground colours for
 * new and existing elements
 */
class ColorChooser extends Canvas implements CbColorWindowCallback
{
	jshock parent;
	Color fore = Color.black, back = Color.white;
	int w, h, xth, yth;
	boolean findent, bindent;
	CbColorWindow fwindow, bwindow;
	Vector pal = new Vector();

	ColorChooser(jshock p)
	{
	parent = p;
	}

	public void paint(Graphics g)
	{
	w = size().width; h = size().height;
	g.setColor(Color.lightGray);
	g.fillRect(0, 0, w, h);
	xth = w*2/3; yth = h*2/3;

	// draw background color
	g.setColor(back);
	g.fillRect(w-xth-3, h-yth-3, xth, yth);
	g.setColor(bindent ? Color.black : Color.white);
	g.drawLine(w-xth-3, h-yth-3, w-4, h-yth-3);
	g.drawLine(w-xth-3, h-yth-3, w-xth-3, h-4);
	g.setColor(bindent ? Color.white : Color.black);
	g.drawLine(w-3, h-3, w-3, h-yth-2);
	g.drawLine(w-3, h-3, w-xth-2, h-3);

	// draw foregound color
	g.setColor(fore);
	g.fillRect(2, 2, xth, yth);
	g.setColor(findent ? Color.black : Color.white);
	g.drawLine(2, 2, xth+1, 2);
	g.drawLine(2, 2, 2, yth+1);
	g.setColor(findent ? Color.white : Color.black);
	g.drawLine(xth+2, yth+2, xth+2, 3);
	g.drawLine(xth+2, yth+2, 3, yth+2);
	}

	public boolean mouseDown(Event e, int x, int y)
	{
	if (x > 2 && y > 2 && x < xth+2 && y < yth+2)
		findent = true;
	else if (x > w-xth-3 && y > h-yth-3 && x < w-3 && y < h-3)
		bindent = true;
	repaint();
	return true;
	}

	public boolean mouseUp(Event e, int x, int y)
	{
	if (x > 0 && y > 0 && x < w && y < h) {
		if (findent && fwindow == null) {
			// pop up foreground colour window
			fwindow = new CbColorWindow(fore, this);
			}
		else if (bindent && bwindow == null) {
			// pop up background color window
			bwindow = new CbColorWindow(back, this);
			}
		}
	findent = bindent = false;
	repaint();
	return true;
	}

	public void chosen(CbColorWindow w, Color c)
	{
	if (c != null) {
		if (w == fwindow) {
			fore = c;
			parent.edit_area.foreChosen(fore);
			}
		else back = c;
		}
	repaint();
	fwindow = bwindow = null;
	}

	public Vector palette(CbColorWindow w)
	{
	return pal;
	}

	public Dimension preferredSize()
	{
	return new Dimension(64, 64);
	}

	public Dimension minimumSize()
	{
	return preferredSize();
	}
}


