import java.awt.*;
import java.util.*;

class CurveElement extends Element
{
	Vector pts;
	Rectangle ob;
	float xfac = 1, yfac = 1;
	boolean resized;

	private float xfac_c, yfac_c;
	int point_c[][];

	void paint(Graphics g, boolean e)
	{
	int p[][] = makePoints();
	g.setColor(fcol);
	g.translate(x, y);
	g.drawPolygon(p[0], p[1], p[0].length);
	g.translate(-x, -y);
	}

	protected int[][] makePoints()
	{
	if (xfac == xfac_c && yfac == yfac_c && point_c != null)
		return point_c;
	point_c = new int[2][pts.size()];
	for(int i=0; i<pts.size(); i++) {
		Point p = scale((Point)pts.elementAt(i));
		point_c[0][i] = p.x; point_c[1][i] = p.y;
		}
	xfac_c = xfac; yfac_c = yfac;
	return point_c;
	}

	private Point scale(Point p)
	{
	if (resized)
		return new Point((int)(p.x * xfac), (int)(p.y * yfac));
	return p;
	}

	void create(Vector p, Color f, Color b)
	{
	pts = p;
	fcol = f;
	ob = getBounds();
	}

	Rectangle getBounds()
	{
	int x1 = Integer.MAX_VALUE, y1 = Integer.MAX_VALUE,
	    x2 = -Integer.MAX_VALUE, y2 = -Integer.MAX_VALUE;
	for(int i=0; i<pts.size(); i++) {
		Point p = scale((Point)pts.elementAt(i));
		int xx = p.x+x, yy = p.y+y;
		if (xx < x1) x1 = xx;
		if (xx > x2) x2 = xx;
		if (yy < y1) y1 = yy;
		if (yy > y2) y2 = yy;
		}
	return new Rectangle(x1, y1, x2-x1, y2-y1);
	}

	void setSize(int nw, int nh)
	{
	xfac = (float)nw/(float)ob.width;
	yfac = (float)nh/(float)ob.height;
	resized = true;
	}

	void copy(Element t)
	{
	CurveElement ct = (CurveElement)t;
	ct.pts = new Vector();
	for(int i=0; i<pts.size(); i++) {
		Point p = (Point)pts.elementAt(i);
		ct.pts.addElement(new Point(p.x, p.y));
		}
	ct.xfac = xfac; ct.yfac = yfac;
	ct.ob = ob; ct.resized = resized;
	super.copy(t);
	}

	HData save()
	{
	HData hd = super.save();
	hd.addVector("pts", pts);
	hd.addFloat("xfac", xfac); hd.addFloat("yfac", yfac);
	return hd;
	}

	void load(HData hd)
	{
	pts = hd.getVector("pts");
	ob = getBounds();
	xfac = hd.getFloat("xfac"); yfac = hd.getFloat("yfac");
	resized = (xfac != 1 || yfac != 1);
	super.load(hd);
	}
}
