import java.awt.*;
import java.io.*;

/**The buttons on the left size of the main window. The user can click on
 * one of these buttons to create an object in the editing window, or to
 * move or edit existing objects.
 * Clicking on the icon for a new object lets the user drag out the object
 * outline in the editing area.
 */
class EditControls extends Panel implements CbButtonCallback
{
	jshock parent;
	CbButton arrow, select, image, text,
		   line, curve, box, fbox,
		   oval, foval, poly, fpoly, 
		   free, ffree, ngon, arc;
	CbButtonGroup gr = new CbButtonGroup();

	EditControls(jshock p)
	{
	parent = p;
	setLayout(new GridLayout(0, 2));
	add(arrow = makeButton("arrow.gif"));
	add(select = makeButton("select.gif"));
	add(image = makeButton("image.gif"));
	add(text = makeButton("text.gif"));
	add(line = makeButton("line.gif"));
	add(curve = makeButton("curve.gif"));
	add(box = makeButton("box.gif"));
	add(fbox = makeButton("fbox.gif"));
	add(oval = makeButton("oval.gif"));
	add(foval = makeButton("foval.gif"));
	add(poly = makeButton("poly.gif"));
	add(fpoly = makeButton("fpoly.gif"));
	add(free = makeButton("free.gif"));
	add(ffree = makeButton("ffree.gif"));
	add(ngon = makeButton("ngon.gif"));
	add(arc = makeButton("arc.gif"));
	arrow.select();
	}

	CbButton makeButton(String s)
	{
	CbButton rv = new CbButton(
		Util.tk.getImage("icons"+File.separator+s), this);
	rv.setGroup(gr);
	return rv;
	}

	public void click(CbButton b)
	{
	EditArea a = parent.edit_area;
	if (b == arrow) a.pointMode();
	else if (b == select)
		a.selectMode();
	else if (b == box)
		a.createMode(EditArea.CREATE_RECT, "BoxElement");
	else if (b == fbox)
		a.createMode(EditArea.CREATE_RECT, "FilledBoxElement");
	else if (b == free)
		a.createMode(EditArea.CREATE_FREE, "FreeElement");
	else if (b == ffree)
		a.createMode(EditArea.CREATE_FREE, "FilledFreeElement");
	else if (b == poly)
		a.createMode(EditArea.CREATE_POLY, "FreeElement");
	else if (b == fpoly)
		a.createMode(EditArea.CREATE_POLY, "FilledFreeElement");
	else if (b == oval)
		a.createMode(EditArea.CREATE_RECT, "OvalElement");
	else if (b == foval)
		a.createMode(EditArea.CREATE_RECT, "FilledOvalElement");
	else if (b == line)
		a.createMode(EditArea.CREATE_LINE, "LineElement");
	else if (b == curve)
		a.createMode(EditArea.CREATE_FREE, "CurveElement");
	else if (b == text)
		a.createMode(EditArea.CREATE_RECT, "TextElement");
	else if (b == image)
		a.createMode(EditArea.CREATE_RECT, "ImageElement");
	else if (b == ngon)
		a.createMode(EditArea.CREATE_RECT, "NGonElement");
	else if (b == arc)
		a.createMode(EditArea.CREATE_LINE, "ArcElement");
	}
}

