import java.awt.*;
import java.util.*;

class GotoTimeLineAction extends Action
{
	String timeline = "";
	int pos;

	void activate(Presentation p)
	{
	for(int i=0; i<p.tl.size(); i++) {
		TimeLine t = (TimeLine)p.tl.elementAt(i);
		if (t.name.equals(timeline)) {
			p.play(t, pos);
			break;
			}
		}
	}

	HData save()
	{
	HData hd = super.save();
	hd.addString("timeline", timeline);
	hd.addInteger("pos", pos);
	return hd;
	}

	void load(HData hd)
	{
	super.load(hd);
	timeline = hd.getString("timeline");
	pos = hd.getInteger("pos");
	}
}


class GotoTimeLineActionEditor extends ActionEditor
{
	GotoTimeLineAction g;
	Choice timeline;
	TextField pos;

	protected void makeUI()
	{
	g = (GotoTimeLineAction)act;
	super.makeUI();
	left.add(new Label("TimeLine:"));
	right.add(timeline = new Choice());
	Vector tl = parent.pres.tl;
	for(int i=0; i<tl.size(); i++)
		timeline.addItem(((TimeLine)tl.elementAt(i)).name);
	timeline.select(g.timeline);
	left.add(new Label("Time:"));
	right.add(pos = new TextField(String.valueOf(g.pos)));
	}

	protected boolean apply()
	{
	String t;
	int p;
	t = timeline.getSelectedItem();
	if ((p = getNum(pos)) < 0) {
		new ErrorWindow("Position must be a positive integer");
		return false;
		}
	if (!super.apply()) return false;
	g.timeline = t;
	g.pos = p;
	return true;
	}
}

