import java.awt.*;
import java.net.*;
import java.applet.*;

class GotoURLAction extends Action
{
	String url;
	String frame;

	void activate(Presentation p)
	{
	if (p.playapl != null) {
		AppletContext cx = p.playapl.getAppletContext();
		try {
			URL u = new URL(p.playapl.getDocumentBase(), url);
			if (frame != null) cx.showDocument(u, frame);
			else cx.showDocument(u);
			}
		catch(Exception e) {
			System.out.println("Invalid URL "+url);
			}
		}
	else System.out.println("Showing URL "+url+" now");
	}

	HData save()
	{
	HData hd = super.save();
	hd.addString("url", url);
	if (frame != null)
		hd.addString("frame", frame);
	return hd;
	}

	void load(HData hd)
	{
	super.load(hd);
	url = hd.getString("url");
	if (hd.contains("frame"))
		frame = hd.getString("frame");
	}
}

class GotoURLActionEditor extends ActionEditor
{
	GotoURLAction g;
	TextField url, frame;

	protected void makeUI()
	{
	g = (GotoURLAction)act;
	super.makeUI();
	left.add(new Label("URL:"));
	right.add(url = new TextField(g.url));
	left.add(new Label("Frame:"));
	right.add(frame = new TextField(g.frame == null ? "" : g.frame));
	}

	protected boolean apply()
	{
	if (!super.apply()) return false;
	g.url = url.getText();
	g.frame = frame.getText();
	if (g.frame.trim().length() == 0)
		g.frame = null;
	return true;
	}
}
