import java.awt.*;
import java.net.*;

class ImageElement extends Element
{
	int w, h;
	Image img;
	String imgsrc;
	int border;

	void paint(Graphics g, boolean e)
	{
	if (img == null) {
		// No image yet
		g.setColor(Color.black);
		g.setXORMode(Color.white);
		g.setFont(Util.f);
		String s = "<None>";
		g.drawString(s, x+(w-Util.fnm.stringWidth(s))/2,
		                y+(h+Util.fnm.getHeight())/2);
		g.setPaintMode();
		}
	else {
		// draw the image
		g.drawImage(img, x+border, y+border,
		            w-border*2, h-border*2, Util.fr);
		}
	// draw border
	g.setColor(bcol);
	for(int i=0; i<border; i++)
		g.drawRect(x+i, y+i, w-1-i*2, h-1-i*2);
	}

	void create(Dimension d, Color f, Color b)
	{
	setSize(d.width, d.height);
	bcol = f;
	}

	Rectangle getBounds()
	{
	return new Rectangle(x, y, w, h);
	}

	void setSize(int nw, int nh)
	{
	w = nw; h = nh;
	if (img != null)
		Util.waitForImage(img, w, h);
	}

	void copy(Element t)
	{
	ImageElement it = (ImageElement)t;
	it.w = w; it.h = h;
	it.img = img; it.imgsrc = imgsrc;
	it.border = border;
	super.copy(t);
	}

	HData save()
	{
	HData hd = super.save();
	hd.addInteger("w", w); hd.addInteger("h", h);
	if (img != null) {
		if (imgsrc != null) hd.addString("imgsrc", imgsrc);
		else hd.addImage("img", img);
		}
	hd.addInteger("border", border);
	return hd;
	}

	void load(HData hd)
	{
	super.load(hd);
	w = hd.getInteger("w"); h = hd.getInteger("h");
	if (hd.contains("imgsrc")) {
		imgsrc = hd.getString("imgsrc");
		try {
			URL u = new URL(imgsrc);
			img = Util.tk.getImage(u);
			}
		catch(Exception e) { }
		if (img == null)
			new ErrorWindow("Failed to load image from "+
			                imgsrc+" in "+name);
		}
	else if (hd.contains("img"))
		img = hd.getImage("img");
	if (img != null)
		Util.waitForImage(img, w, h);
	border = hd.getInteger("border");
	}
}

