import java.awt.*;

class ImageElementEditor extends ElementEditor
{
	TextField width, height, border;
	Checkbox auto, nauto;
	CbImageChooser img;
	Checkbox stored, storeu;
	CbColorButton bcol;
	ImageElement i;

	protected void makeUI()
	{
	super.makeUI();
	i = (ImageElement)elm;
	pan.setLayout(new GridLayout(0, 2));
	pan.add(new Label("Width:"));
	pan.add(width = new TextField(String.valueOf(i.w)));
	pan.add(new Label("Height:"));
	pan.add(height = new TextField(String.valueOf(i.h)));
	pan.add(new Label("Automatic size:"));
	Panel sp = new GrayPanel();
	sp.setLayout(new GridLayout(1, 2));
	CheckboxGroup sg = new CheckboxGroup();
	boolean autosize =
	  (i.img != null &&
	   i.w == i.border*2+Util.getWidth(i.img) &&
	   i.h == i.border*2+Util.getHeight(i.img));
	sp.add(auto = new Checkbox("Yes", sg, autosize));
	sp.add(nauto = new Checkbox("No", sg, !autosize));
	pan.add(sp);
	pan.add(new Label("Image:"));
	pan.add(img = new CbImageChooser(i.img, i.imgsrc));
	pan.add(new Label("Store Image:"));
	Panel up = new GrayPanel();
	up.setLayout(new GridLayout(1, 2));
	CheckboxGroup ug = new CheckboxGroup();
	up.add(storeu = new Checkbox("URL", ug,
                                   i.img==null || i.imgsrc!=null));
	up.add(stored = new Checkbox("Data", ug, !storeu.getState()));
	pan.add(up);
	pan.add(new Label("Border:"));
	pan.add(border = new TextField(String.valueOf(i.border)));
	pan.add(new Label("Border Color:"));
	pan.add(bcol = new CbColorButton(i.bcol));
	}

	protected boolean apply()
	{
	int w, h, b;
	if ((b = getNum(border)) < 0 || b > 10) {
		new ErrorWindow("Border must be a positive number "+
				"less than 10");
		return false;
		}
	Color c = bcol.col;
	Image m = img.img;
	if (auto.getState() && img != null) {
		w = b*2 + Util.getWidth(m);
		h = b*2 + Util.getHeight(m);
		}
	else {
		if ((w = getNum(width)) < 0) {
			new ErrorWindow("Width must be a positive number");
			return false;
			}
		if ((h = getNum(height)) < 0) {
			new ErrorWindow("Height must be a positive number");
			return false;
			}
		}
	String s = m==null || stored.getState() ? null : img.imgsrc;
	if (storeu.getState() && m != null) {
		if (s == null) {
			new ErrorWindow("Only images for which the source "+
			                "is known can be stored as URLs");
			return false;
			}
		else if (!s.startsWith("http:") && !s.startsWith("https:")) {
			new ErrorWindow("Only images loaded from a URL can be "+
			                "stored as URLs");
			return false;
			}
		}
	if (!super.apply()) return false;
	i.w = w; i.h = h;
	i.border = b; i.bcol = c;
	i.img = m;
	i.imgsrc = s;
	return true;
	}
}

