import java.awt.*;

class LineElement extends Element
{
	int xoff, yoff, thick = 1;
	boolean arrow1, arrow2;

	void paint(Graphics g, boolean e)
	{
	g.setColor(fcol);
	float len = (float)Math.sqrt(xoff*xoff + yoff*yoff);
	float xr = thick*-yoff/len, yr = thick*xoff/len,
	      xv = thick*xoff/len, yv = thick*yoff/len;
	if (thick == 1)
		g.drawLine(x, y, x+xoff, y+yoff);
	else {
		int xp[] = { x+(int)xr, x-(int)xr, x+xoff-(int)xr, x+xoff+(int)xr },
		    yp[] = { y+(int)yr, y-(int)yr, y+yoff-(int)yr, y+yoff+(int)yr };
		g.fillPolygon(xp, yp, 4);
		}
	int xxr = (int)(xr*4), yyr = (int)(yr*4),
	    xxv = (int)(xv*8), yyv = (int)(yv*8);
	if (arrow1) {
		int xp[] = { x-xxr, x+xxr, x-xxv };
		int yp[] = { y-yyr, y+yyr, y-yyv };
		g.fillPolygon(xp, yp, 3);
		}
	if (arrow2) {
		int xp[] = { x+xoff-xxr, x+xoff+xxr, x+xoff+xxv };
		int yp[] = { y+yoff-yyr, y+yoff+yyr, y+yoff+yyv };
		g.fillPolygon(xp, yp, 3);
		}
	}

	void create(Dimension d, Color f, Color b)
	{
	xoff = d.width; yoff = d.height;
	fcol = f;
	}

	int getStyle()
	{
	return 1;
	}

	Point[] getEndPoints()
	{
	Point rv[] = { new Point(x, y), new Point(x+xoff, y+yoff) };
	return rv;
	}

	void setSize(int nw, int nh)
	{
	xoff = nw; yoff = nh;
	}

	void copy(Element t)
	{
	LineElement lt = (LineElement)t;
	lt.xoff = xoff; lt.yoff = yoff;
	lt.thick = thick;
	lt.arrow1 = arrow1; lt.arrow2 = arrow2;
	super.copy(t);
	}

	HData save()
	{
	HData hd = super.save();
	hd.addInteger("xoff", xoff); hd.addInteger("yoff", yoff);
	hd.addInteger("thick", thick);
	hd.addBoolean("arrow1", arrow1);
	hd.addBoolean("arrow2", arrow2);
	return hd;
	}

	void load(HData hd)
	{
	super.load(hd);
	xoff = hd.getInteger("xoff"); yoff = hd.getInteger("yoff");
	thick = hd.getInteger("thick");
	arrow1 = hd.getBoolean("arrow1");
	arrow2 = hd.getBoolean("arrow2");
	}
}