import java.awt.*;

public class LineElementEditor extends ElementEditor
{
	LineElement l;
	TextField xoff, yoff, thick;
	CbColorButton fcol;
	Choice arrows;

	protected void makeUI()
	{
	super.makeUI();
	l = (LineElement)elm;
	pan.setLayout(new GridLayout(0, 2));
	pan.add(new Label("X offset:"));
	pan.add(xoff = new TextField(String.valueOf(l.xoff)));
	pan.add(new Label("Y offset:"));
	pan.add(yoff = new TextField(String.valueOf(l.yoff)));
	pan.add(new Label("Thickness:"));
	pan.add(thick = new TextField(String.valueOf(l.thick)));
	pan.add(new Label("Color:"));
	pan.add(fcol = new CbColorButton(l.fcol));
	pan.add(new Label("Arrows:"));
	pan.add(arrows = new Choice());
	arrows.addItem("None");
	arrows.addItem("Start");
	arrows.addItem("End");
	arrows.addItem("Both");
	arrows.select((l.arrow1?1:0) + (l.arrow2?2:0));
	}

	protected boolean apply()
	{
	int x, y, t;
	if ((x = getNum(xoff)) == -Integer.MAX_VALUE) {
		new ErrorWindow("X offset must be a positive number");
		return false;
		}
	if ((y = getNum(yoff)) == -Integer.MAX_VALUE) {
		new ErrorWindow("Y offset must be a positive number");
		return false;
		}
	if ((t = getNum(thick)) <= 0 || t > 10) {
		new ErrorWindow("Thickness must be a positive number "+
		                "less than 10");
		return false;
		}
	if (!super.apply()) return false;
	l.xoff = x; l.yoff = y;
	l.thick = t; l.fcol = fcol.col;
	l.arrow1 = (arrows.getSelectedIndex()%2 == 1);
	l.arrow2 = (arrows.getSelectedIndex() > 1);
	return true; 
	}
}