import java.awt.*;

class NGonElement extends Element
{
	int w,h;
	int sides = 8, offset = 0;

	void paint(Graphics g, boolean e)
	{
	int rx = w/2, ry = h/2, mx = x+rx, my = y+ry;;
	float circ = (float)(Math.PI*2);
	float s = circ/sides;
	int px, py, nx, ny;
	g.setColor(fcol);
	float o = (float)(offset*Math.PI/180)-s/2;
	px = (int)(Math.cos(o)*rx + mx);
	py = (int)(Math.sin(o)*ry + my);
	for(float a=o; a<circ; a+=s) {
		nx = (int)(Math.cos(a)*rx + mx);
		ny = (int)(Math.sin(a)*ry + my);
		g.drawLine(px, py, nx, ny);
		px = nx; py = ny;
		}
	}

	void create(Dimension d, Color f, Color b)
	{
	setSize(d.width, d.height);
	fcol = f;
	}

	void setSize(int nw, int nh)
	{
	w = nw; h = nh;
	}

	Rectangle getBounds()
	{
	return new Rectangle(x, y, w, h);
	}

	void copy(Element t)
	{
	NGonElement nt = (NGonElement)t;
	nt.w = w; nt.h = h;
	nt.sides = sides; nt.offset = offset;
	}

	HData save()
	{
	HData hd = super.save();
	hd.addInteger("w", w); hd.addInteger("h", h);
	hd.addInteger("sides", sides); hd.addInteger("offset", offset);
	return hd;
	}

	void load(HData hd)
	{
	super.load(hd);
	w = hd.getInteger("w"); h = hd.getInteger("h");
	sides = hd.getInteger("sides"); offset = hd.getInteger("offset");
	}
}
