import java.awt.*;

class NGonElementEditor extends ElementEditor
{
	TextField width, height, sides, offset;
	CbColorButton fcol;
	NGonElement n;

	protected void makeUI()
	{
	super.makeUI();
	n = (NGonElement)elm;
	pan.setLayout(new GridLayout(0, 2));
	pan.add(new Label("Width:"));
	pan.add(width = new TextField(String.valueOf(n.w)));
	pan.add(new Label("Height:"));
	pan.add(height = new TextField(String.valueOf(n.h)));
	pan.add(new Label("Sides:"));
	pan.add(sides = new TextField(String.valueOf(n.sides)));
	pan.add(new Label("Offset:"));
	pan.add(offset = new TextField(String.valueOf(n.offset)));
	pan.add(new Label("Color:"));
	pan.add(fcol = new CbColorButton(n.fcol));
	}

	protected boolean apply()
	{
	int w, h, s, o;
	if ((w = getNum(width)) < 0) {
		new ErrorWindow("Width must be a positive number");
		return false;
		}
	if ((h = getNum(height)) < 0) {
		new ErrorWindow("Height must be a positive number");
		return false;
		}
	if ((s = getNum(sides)) < 0 || s > 100) {
		new ErrorWindow("The number of sides must be a positive "+
				"number less than 100");
		return false;
		}
	if ((o = getNum(offset)) < 0) {
		new ErrorWindow("Offset angle must be a positive number");
		return false;
		}
	Color c = fcol.col;
	if (!super.apply()) return false;
	n.w = w; n.h = h;
	n.sides = s; n.offset = o;
	n.fcol = c;
	return true;
	}
}

