import java.awt.*;

class OvalElement extends Element
{
	int w, h;
	int thick = 1;

	void paint(Graphics g, boolean e)
	{
	g.setColor(fcol);
	for(int i=0; i<thick; i++)
		g.drawOval(x+i, y+i, w-i*2, h-i*2);
	}

	void create(Dimension d, Color f, Color b)
	{
	setSize(d.width, d.height);
	fcol = f;
	}

	Rectangle getBounds()
	{
	return new Rectangle(x, y, w, h);
	}

	void setSize(int nw, int nh)
	{
	w = nw; h = nh;
	}

	void copy(Element t)
	{
	OvalElement ot = (OvalElement)t;
	ot.w = w; ot.h = h;
	ot.thick = thick;
	super.copy(t);
	}

	HData save()
	{
	HData hd = super.save();
	hd.addInteger("w", w); hd.addInteger("h", h);
	hd.addInteger("thick", thick);
	return hd;
	}

	void load(HData hd)
	{
	super.load(hd);
	w = hd.getInteger("w"); h = hd.getInteger("h");
	thick = hd.getInteger("thick");
	}
}

