import java.awt.*;

class OvalElementEditor extends ElementEditor
{
	TextField width, height, thick;
	CbColorButton fcol;
	OvalElement o;

	protected void makeUI()
	{
	super.makeUI();
	o = (OvalElement)elm;
	pan.setLayout(new GridLayout(0, 2));
	pan.add(new Label("Width:"));
	pan.add(width = new TextField(String.valueOf(o.w)));
	pan.add(new Label("Height:"));
	pan.add(height = new TextField(String.valueOf(o.h)));
	pan.add(new Label("Thickness:"));
	pan.add(thick = new TextField(String.valueOf(o.thick)));
	pan.add(new Label("Color:"));
	pan.add(fcol = new CbColorButton(o.fcol));
	}

	protected boolean apply()
	{
	int w, h, t;
	if ((w = getNum(width)) < 0) {
		new ErrorWindow("Width must be a positive number");
		return false;
		}
	if ((h = getNum(height)) < 0) {
		new ErrorWindow("Height must be a positive number");
		return false;
		}
	if ((t = getNum(thick)) < 0 || t > 10) {
		new ErrorWindow("Thickness must be a positive number "+
				"less than 10");
		return false;
		}
	Color c = fcol.col;
	if (!super.apply()) return false;
	o.w = w;
	o.h = h;
	o.thick = t;
	o.fcol = c;
	return true;
	}
}
