import java.awt.*;
import java.net.*;
import java.applet.*;

class PlaySoundAction extends Action implements Runnable
{
	String url = "";
	boolean loop;
	int len;
	private AudioClip clip;

	void activate(Presentation p)
	{
	if (p.playapl == null) {
		System.out.println("Playing sound "+url);
		return;
		}
	if (clip == null) {
		try { clip = p.playapl.getAudioClip(
			new URL(p.playapl.getDocumentBase(), url)); }
		catch(Exception e) {
			System.out.println(url+" is not a valid URL");
			e.printStackTrace();
			}
		}
	if (clip != null)
		new Thread(this).start();
	}

	public void run()
	{
	if (!loop) clip.play();
	else {
		clip.loop();
		try { Thread.sleep(len); } catch(Exception e) { }
		clip.stop();
		}
	}

	HData save()
	{
	HData hd = super.save();
	hd.addString("url", url);
	hd.addInteger("len", len);
	hd.addBoolean("loop", loop);
	return hd;
	}

	void load(HData hd)
	{
	super.load(hd);
	url = hd.getString("url");
	len = hd.getInteger("len");
	loop = hd.getBoolean("loop");
	}
}

class PlaySoundActionEditor extends ActionEditor
{
	PlaySoundAction p;
	TextField url, len;
	Choice mode;

	protected void makeUI()
	{
	super.makeUI();
	p = (PlaySoundAction)act;
	left.add(new Label("URL:"));
	right.add(url = new TextField(p.url));
	left.add(new Label("Play mode:"));
	right.add(mode = new Choice());
	mode.addItem("Once"); mode.addItem("Loop");
	mode.select(p.loop ? 1 : 0);
	left.add(new Label("Loop time:"));
	Panel r = new GrayPanel();
	r.setLayout(new BorderLayout());
	r.add("East", new Label("ms"));
	r.add("Center", len = new TextField(String.valueOf(p.len)));
	right.add(r);
	}

	protected boolean apply()
	{
	String u = url.getText();
	boolean m = (mode.getSelectedIndex()==1);
	int l;
	if ((l = getNum(len)) < 0) {
		new ErrorWindow("Loop time must be a number >= 0");
		return false;
		}
	if (!super.apply()) return false;
	p.url = u;
	p.loop = m;
	p.len = l;
	return true;
	}
}

