import java.awt.*;

class RunWindow extends FixedFrame implements CbButtonCallback
{
	Presentation pres;
	CbButton pause, close;
	RunPanel rp;
	boolean paused = false;

	RunWindow(Presentation p)
	{
	pres = new Presentation(p.save());
	setLayout(new BorderLayout());
	Panel bot = new GrayPanel();
	bot.setLayout(new FlowLayout(FlowLayout.RIGHT));
	bot.add(pause = new CbButton("Pause", this));
	bot.add(close = new CbButton("Close", this));
	add("South", bot);

	Panel mid = new BorderPanel(1);
	mid.add("Center", rp = new RunPanel(this));
	add("Center", mid);
	pack();
	show();
	setTitle("Run Presentation");
	}

	public void click(CbButton b)
	{
	if (b == pause) {
		paused = !paused;
		if (paused) {
			pause.setText("Play");
			pres.pause();
			}
		else {
			pause.setText("Pause");
			pres.unpause();
			}
		}
	else if (b == close)
		dispose();
	}

	public void dispose()
	{
	pres.halt();
	super.dispose();
	}
}


class RunPanel extends Panel
{
	RunWindow parent;
	Presentation pres;
	Button dummy;
	boolean firstpaint = true;

	RunPanel(RunWindow p)
	{
	parent = p;
	pres = parent.pres;
	add(dummy = new Button());
	dummy.hide();
	}

	public void paint(Graphics g)
	{
	if (firstpaint) {
		firstpaint = false;
		pres.setup(createImage(size().width, size().height),
			   this, dummy);
		pres.play();
		}
	else
		pres.paint();
	}

	public boolean mouseDown(Event evt, int mx, int my)
	{
	pres.mouseClick(mx, my);
	return true;
	}

	public boolean mouseMove(Event evt, int mx, int my)
	{
	pres.mouseMove(mx, my);
	return true;
	}

	public boolean mouseExit(Event evt, int mx, int my)
	{
	return mouseMove(evt, mx, my);
	}

	public Dimension minimumSize()
	{
	return new Dimension(parent.pres.w, parent.pres.h);
	}

	public Dimension preferredSize()
	{
	return minimumSize();
	}
}

