import java.awt.*;

class SetColorAction extends Action
{
	String elm;
	Color fcol = Color.black, bcol = Color.white;
	int fmode, bmode;

	void activate(Presentation p)
	{
	Element e = p.findElement(elm);
	if (e == null) {
		System.out.println("Failed to find element "+elm);
		return;
		}
	if (fmode == 1) e.fcol = fcol;
	if (bmode == 1) e.bcol = bcol;
	p.changed();
	}

	HData save()
	{
	HData hd = super.save();
	hd.addString("elm", elm);
	hd.addColor("fcol", fcol);
	hd.addColor("bcol", bcol);
	hd.addInteger("fmode", fmode);
	hd.addInteger("bmode", bmode);
	return hd;
	}

	void load(HData hd)
	{
	super.load(hd);
	elm = hd.getString("elm");
	fcol = hd.getColor("fcol");
	bcol = hd.getColor("bcol");
	fmode = hd.getInteger("fmode");
	bmode = hd.getInteger("bmode");
	}
}

class SetColorActionEditor extends ActionEditor
{
	SetColorAction s;
	Choice elm, fmode, bmode;
	CbColorButton fcol, bcol;

	protected void makeUI()
	{
	super.makeUI();
	s = (SetColorAction)act;

	left.add(new Label("Element:"));
	right.add(elm = new Choice());
	Element el[] = parent.pres.listElements();
	for(int i=0; i<el.length; i++) elm.addItem(el[i].name);
	if (el.length == 0) elm.addItem("<None>");
	if (s.elm != null) elm.select(s.elm);

	left.add(new Label("Foreground:"));
	right.add(fcol = new CbColorButton(s.fcol));
	left.add(new Label("Change Fg:"));
	right.add(fmode = new Choice());
	fmode.addItem("No"); fmode.addItem("Yes");
	fmode.select(s.fmode);

	left.add(new Label("Background:"));
	right.add(bcol = new CbColorButton(s.bcol));
	left.add(new Label("Change Bg:"));
	right.add(bmode = new Choice());
	bmode.addItem("No"); bmode.addItem("Yes");
	bmode.select(s.bmode);
	}

	protected boolean apply()
	{
	String e;
	if (parent.pres.findElement(e = elm.getSelectedItem()) == null) {
		new ErrorWindow("Element "+e+" not found");
		return false;
		}
	Color f = fcol.col, b = bcol.col;
	int fm = fmode.getSelectedIndex(), bm = bmode.getSelectedIndex();
	if (!super.apply()) return false;
	s.elm = e;
	s.fcol = f; s.bcol = b;
	s.fmode = fm; s.bmode = bm;
	return true;
	}
}

