import java.awt.*;

class SetSizeAction extends Action
{
	String elm;
	int w, h;
	int wmode = 0, hmode = 0;

	void activate(Presentation p)
	{
	Element e = p.findElement(elm);
	if (e == null) {
		System.out.println("Failed to find elememnt "+elm);
		return;
		}
	int s = e.getStyle();
	int ow, oh;
	if (s == 0) {
		Rectangle d = e.getBounds();
		ow = d.width; oh = d.height;
		}
	else {
		Point ep[] = e.getEndPoints();
		ow = ep[1].x - ep[0].x;
		oh = ep[1].y - ep[0].y;
		}
	if (wmode == 1) ow = w;
	else if (wmode == 2) ow += w;
	if (hmode == 1) oh = h;
	else if (hmode == 2) oh += h;
	e.setSize(ow, oh);
	p.changed();
	}

	HData save()
	{
	HData hd = super.save();
	hd.addString("elm", elm);
	hd.addInteger("w", w); hd.addInteger("h", h);
	hd.addInteger("wmode", wmode); hd.addInteger("hmode", hmode);
	return hd;
	}

	void load(HData hd)
	{
	super.load(hd);
	elm = hd.getString("elm");
	w = hd.getInteger("w"); h = hd.getInteger("h");
	wmode = hd.getInteger("wmode"); hmode = hd.getInteger("hmode");
	}
}

class SetSizeActionEditor extends ActionEditor
{
	SetSizeAction s;
	TextField width, height;
	Choice elm, wmode, hmode;

	protected void makeUI()
	{
	super.makeUI();
	s = (SetSizeAction)act;
	left.add(new Label("Element:"));
	right.add(elm = new Choice());
	Element el[] = parent.pres.listElements();
	for(int i=0; i<el.length; i++)
		elm.addItem(el[i].name);
	if (el.length == 0) elm.addItem("<None>");
	if (s.elm != null) elm.select(s.elm);

	left.add(new Label("Width:"));
	right.add(width = new TextField(String.valueOf(s.w)));
	left.add(new Label("Change Width:"));
	right.add(wmode = new Choice());
	wmode.addItem("No"); wmode.addItem("Absolute");
	wmode.addItem("Relative"); wmode.select(s.wmode);

	left.add(new Label("Height:"));
	right.add(height = new TextField(String.valueOf(s.h)));
	left.add(new Label("Change Height:"));
	right.add(hmode = new Choice());
	hmode.addItem("No"); hmode.addItem("Absolute");
	hmode.addItem("Relative"); hmode.select(s.hmode);
	}

	protected boolean apply()
	{
	String e;
	int wm, hm, w, h;
	if (parent.pres.findElement(e = elm.getSelectedItem()) == null) {
		new ErrorWindow("Element "+e+" not found");
		return false;
		}
	wm = wmode.getSelectedIndex();
	if ((w = getNum(width)) == -Integer.MAX_VALUE) {
		new ErrorWindow("Width must be a number");
		}
	hm = hmode.getSelectedIndex();
	if ((h = getNum(height)) == -Integer.MAX_VALUE) {
		new ErrorWindow("Height must be a number");
		}
	if (!super.apply()) return false;
	s.elm = e;
	s.w = w; s.h = h;
	s.wmode = wm; s.hmode = hm;
	return true;
	}
}
