import java.awt.*;
import java.net.*;
import java.io.*;
import java.applet.*;

public class jshockApplet extends Applet
{
	String error;
	Presentation pres;
	Button pause, rewind;
	int buttonw, buttonh;
	boolean paused, showing = true;
	boolean startpaused;

	public void init()
	{
	// Check and get parameters
	String p = getParameter("presentation");
	if (p == null) {
		error = "Missing presentation parameter";
		return;
		}
	boolean buttons = (getParameter("buttons") != null);
	startpaused = (getParameter("startpaused") != null);

	// Get the presentation URL
	URL u;
	try { u = new URL(getDocumentBase(), p); }
	catch(Exception e) {
		error = "Invalid URL "+p;
		return;
		}

	// Read the presentation
	try {
		InputStream is = u.openStream();
		pres = new Presentation(is);
		is.close();
		}
	catch(Exception e) {
		error = "Failed to read presentation from "+u;
		return;
		}

	// setup buttons
	if (buttons) {
		setLayout(null);
		add(pause = new Button("Pause"));
		add(rewind = new Button("Rewind"));
		Dimension ps = pause.preferredSize(),
			  rs = rewind.preferredSize();
		pause.reshape(5, 5, ps.width, ps.height);
		rewind.reshape(ps.width+10, 5, rs.width, rs.height);
		}

	Button dummy = new Button();
	add(dummy);
	dummy.hide();
	pres.setup(createImage(size().width, size().height),
		   this, dummy);
	}

	public void start()
	{
	if (pres != null) {
		pres.play();
		if (startpaused) {
			pres.pause();
			paused = true;
			pause.setLabel("Play");
			}
		}
	}

	public void stop()
	{
	if (pres != null) pres.halt();
	}

	public void paint(Graphics g)
	{
	if (error != null) {
		int w = size().width, h = size().height;
		g.setColor(Color.lightGray);
		g.fillRect(0, 0, w, h);
		g.setColor(Color.black);
		g.setFont(Util.f);
		g.drawString(error, (w-Util.fnm.stringWidth(error))/2,
		                    (h+Util.fnm.getHeight())/2);
		}
	else
		pres.paint();
	}

	public void update(Graphics g) { paint(g); }

	public boolean mouseMove(Event e, int mx, int my)
	{
	pres.mouseMove(mx, my);
	return true;
	}

	public boolean mouseExit(Event e, int mx, int my)
	{
	return mouseMove(e, mx, my);
	}

	public boolean action(Event evt, Object obj)
	{
	if (evt.target == pause) {
		// Pause or unpause presentation
		if (paused) {
			pres.unpause();
			pause.setLabel("Pause");
			}
		else {
			pres.pause();
			pause.setLabel("Play");
			}
		paused = !paused;
		}
	else if (evt.target == rewind) {
		// Go back to the start
		pres.play();
		paused = false;
		pause.setLabel("Pause");
		}
	return true;
	}

	public boolean mouseDown(Event evt, int mx, int my)
	{
	pres.mouseClick(mx, my);
	return true;
	}
}

